{ 000401-5.PAS                                                              }
{ 2000-04-01 programmeerimisolmpiaadi 5. lesande lahendus                 }
{    TEHAS                                                                  }
{ Oleg Mrk                                                                 }
{ Testitud: TP 7.0, FPC 0.99.10                                             }

{$m 65520, 0, 655360}
{$I+}{$R+}{$S+}{$Q+}

const
 MAX_M = 10;
 MAX_J = 10;
 MAX_O = 10;
 MAX_TIME = MaxLongInt;
 INPUT_FILE = 'tehas.sis';
 OUTPUT_FILE = 'tehas.val';

type
 operation = record
              mashine:longint;
              len:longint;
             end;
 job = record
        cnt:longint;
        op:array[1..MAX_O] of operation;
       end;
 assigment = record
              t:longint;
              job, op:longint;
             end;
 log = array[1 .. MAX_J * MAX_O] of assigment;

var
 jobs:array[1..MAX_J] of job;

 m,j:longint;

 m_time:array[1..MAX_M] of longint;
 j_time:array[1..MAX_J] of longint;
 j_left:array[1..MAX_J] of longint;
 j_pos:array[1..MAX_J] of longint;

 wrk_log_n:longint;
 wrk_log:log;

 best:longint;
 best_log_n:longint;
 best_log:log;

 limit:longint;
 next:longint;


function max(a,b:longint):longint;
begin
 if (a<b) then max:=b else max:=a;
end;


function min(a,b:longint):longint;
begin
 if (a>b) then min:=b else min:=a;
end;


procedure search(last:longint);
var
 l:longint;
 was:boolean;
 x_len, x_time:longint;
 x_mas, x_pos:longint;
 s_m_time, s_j_time:longint;
 estimate:longint;

begin

 {Building estimation of time}
 was:=false;
 estimate := 0;

 for l:=1 to j do
  if (j_pos[l] < jobs[l].cnt) then
  begin
   was:=true;

   x_pos := j_pos[l] + 1;
   x_mas := jobs[l].op[x_pos].mashine;
   x_time := max(j_time[l], m_time[x_mas]);

   estimate := max(estimate, x_time + j_left[l]);
  end
  else estimate := max(estimate, j_time[l]);

 if not was then
 begin
  {Solution found!}
  best := min(best, last);
  best_log_n := wrk_log_n;
  best_log := wrk_log;
  exit;
 end;

 if (estimate > limit) then
 begin
  next := min(next, estimate);
  exit;
 end;

 if (estimate >= best) then exit;


 {Trying to make one step of each job}
 for l:=1 to j do
  if (j_pos[l] < jobs[l].cnt) then
  begin
   was:=true;

   x_pos := j_pos[l] + 1;
   x_mas := jobs[l].op[x_pos].mashine;
   x_len := jobs[l].op[x_pos].len;
   x_time := max(j_time[l], m_time[x_mas]);

   inc(wrk_log_n);
   wrk_log[wrk_log_n].t   := x_time;
   wrk_log[wrk_log_n].job := l;
   wrk_log[wrk_log_n].op  := x_pos;

   s_m_time := m_time[x_mas];
   s_j_time := j_time[l];

   m_time[x_mas] := x_time + x_len;
   j_time[l] := x_time + x_len;
   dec(j_left[l], x_len);
   inc(j_pos[l]);

   search(max(last, x_time + x_len));

   dec(j_pos[l]);
   inc(j_left[l], x_len);
   j_time[l] := s_j_time;
   m_time[x_mas] := s_m_time;

   dec(wrk_log_n);
  end;

end;



procedure control;
var
 l, k:longint;
begin
 for l:=1 to m do m_time[l]:=0;
 for l:=1 to j do
 begin
  j_time[l]:= 0;
  j_pos[l] := 0;
  j_left[l]:= 0;
  for k:=1 to jobs[l].cnt do
   inc(j_left[l], jobs[l].op[k].len);
 end;

 best := MAX_TIME;
 limit := 1;

 while best = MAX_TIME do
 begin
  limit:= next;
  next := MAX_TIME;
  search(0);
 end;
end;



procedure sort;
var
 l,l1:integer;
 temp: assigment;
begin
 for l:=1 to best_log_n - 1 do
  for l1:= l+1 to best_log_n do
   if best_log[l].t > best_log[l1].t then
   begin
    temp := best_log[l];
    best_log[l]:= best_log[l1];
    best_log[l1]:= temp;
   end;
end;


procedure read_data;
var
 f:text;
 l, k:longint;

begin
 assign(f, INPUT_FILE);
 reset(f);

 readln(f, m, j);
 for l:=1 to j do
 begin
  read(f, jobs[l].cnt);
  for k:=1 to jobs[l].cnt do
   read(f, jobs[l].op[k].mashine, jobs[l].op[k].len);
  readln(f);
 end;
 close(f);
end;

procedure write_data;
var
 f:text;
 l:longint;
begin
 assign(f, OUTPUT_FILE);
 rewrite(f);
 writeln(f, best);
 writeln(f, best_log_n);
 for l:=1 to best_log_n do
  writeln(f, best_log[l].t:6, best_log[l].job:6, best_log[l].op:6);
 close(f);
end;

begin
 read_data;
 control;
 sort;
 write_data;
end.