{ kontroll.pas                                                              }
{ 2000-04-01 programmeerimisolmpiaadi 2. lesande testija                  }
{    JOONISE PGAMINE                                                       }
{ Ahto Truu                                                                 }

{$I-}

const
   maxn = 1000;                                   { maksimaalne likude arv }
   maxk = 1000;                                    { maksimaalne koordinaat }
   maxv = 0.001;                                 { maksimaalne lubatud viga }

type
   punkt = record
      x, y : real;
   end;

{ leiab sirgete (p1,p2) ja x=p3.x likepunkti }
procedure loika_x (p1, p2, p3 : punkt; var p : punkt);
begin
   p.x := p3.x;
   p.y := p1.y + (p3.x - p1.x) * (p2.y - p1.y) / (p2.x - p1.x);
end;

{ leiab sirgete (p1,p2) ja y=p3.y likepunkti }
procedure loika_y (p1, p2, p3 : punkt; var p : punkt);
begin
   p.x := p1.x + (p3.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y);
   p.y := p3.y;
end;

{ pgab antud ligu antud aknaga; tagastab true, kui midagi alles ka ji }
function puga_loik (a1, a2 : punkt; var l1, l2 : punkt) : boolean;
var p1, p2 : ^punkt;
begin
   puga_loik := true;

      { paneme p1 osutama vasaku ja p2 parema otspunkti peale }
   if l1.x < l2.x then begin
      p1 := @l1; p2 := @l2;
   end else begin
      p1 := @l2; p2 := @l1;
   end;
      { jtame alles sirgete x=a1.x ja x=a2.x  vahel oleva osa }
   if (p2^.x < a1.x) or (p1^.x > a2.x) then
      puga_loik := false
   else begin
      if p1^.x < a1.x then
         loika_x (p1^, p2^, a1, p1^);
      if a2.x < p2^.x then
         loika_x (p1^, p2^, a2, p2^);
   end;

      { paneme p1 osutama alumise ja p2 lemise otspunkti peale }
   if l1.y < l2.y then begin
      p1 := @l1; p2 := @l2;
   end else begin
      p1 := @l2; p2 := @l1;
   end;
      { jtame alles sirgete y=a1.y ja y=a2.y  vahel oleva osa }
   if (p2^.y < a1.y) or (p1^.y > a2.y) then
      puga_loik := false
   else begin
      if p1^.y < a1.y then
         loika_y (p1^, p2^, a1, p1^);
      if a2.y < p2^.y then
         loika_y (p1^, p2^, a2, p2^);
   end;
end;

function lahuta_rida (s : string; var p1, p2 : punkt) : boolean;
var i, u : integer;
begin
   lahuta_rida := false;
      { 1. arv }
   i := pos (' ', s);
   if i = 0 then exit;
   val (copy (s, 1, i - 1), p1.x, u);
   if u <> 0 then exit;
   delete (s, 1, i);
      { 2. arv }
   i := pos (' ', s);
   if i = 0 then exit;
   val (copy (s, 1, i - 1), p1.y, u);
   if u <> 0 then exit;
   delete (s, 1, i);
      { 3. arv }
   i := pos (' ', s);
   if i = 0 then exit;
   val (copy (s, 1, i - 1), p2.x, u);
   if u <> 0 then exit;
   delete (s, 1, i);
      { 4. arv }
   val (s, p2.y, u);
   if u <> 0 then exit;
      { korras }
   lahuta_rida := true;
end;

function klapivad (p1, p2 : punkt) : boolean;
begin
   klapivad := (abs (p1.x - p2.x) < maxv) and (abs (p1.y - p2.y) < maxv);
end;

var
   fs, fv : text;
   a1, a2 : punkt;                                            { akna nurgad }
   l1, l2 : punkt;                                       { ligu otspunktid }
   p1, p2 : punkt;                               { pgatud ligu otspunktid }
   s : string;
   n, i, k : integer;

begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   assign (fv, paramstr (2)); reset (fv);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   assign (fs, paramstr (1)); reset (fs);
   readln (fs, a1.x, a1.y, a2.x, a2.y);
   readln (fs, n); k := 0;
   for i := 1 to n do begin
      if eof (fv) then begin
         writeln ('Faili ', paramstr (2), ' enneaegne lpp');
         halt (1);
      end;
      readln (fv, s);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;

      readln (fs, l1.x, l1.y, l2.x, l2.y);
      if puga_loik (a1, a2, l1, l2) then begin
         if not lahuta_rida (s, p1, p2) then begin
            writeln ('Viga faili ', paramstr (2), ' real ', i, ':');
            writeln ('   Peaks olema: ', l1.x :0:3, ' ', l1.y :0:3, ' ', l2.x :0:3, ' ', l2.y :0:3);
            writeln ('   Aga on     : ', s);
            k := k + 1;
         end else if klapivad (l1, p1) and klapivad (l2, p2) then begin
            { korras }
         end else if klapivad (l1, p2) and klapivad (l2, p1) then begin
            { korras }
         end else begin
            writeln ('Viga faili ', paramstr (2), ' real ', i, ':');
            writeln ('   Peaks olema: ', l1.x :0:3, ' ', l1.y :0:3, ' ', l2.x :0:3, ' ', l2.y :0:3);
            writeln ('   Aga on     : ', s);
            k := k + 1;
         end;
      end else begin
         if s <> 'OUT' then begin
            writeln ('Viga faili ', paramstr (2), ' real ', i, ':');
            writeln ('   Peaks olema: OUT');
            writeln ('   Aga on     : ', s);
            k := k + 1;
         end;
            
      end;
   end;

   if k = 0 then
      writeln ('Korras');

   close (fs);
   close (fv);
end.
