{$m 65520, 0, 655360}
{$I+}{$R+}{$S+}{$Q+}

const
 MAX_M = 10;
 MAX_J = 10;
 MAX_O = 10;
 MAX_TIME = MaxLongInt;
 INPUT_FILE = 'tehas.sis';
 OUTPUT_FILE = 'tehas.val';

const
 IO_ERROR = 'I/O Error';
 WRONG_JOB = 'Wrong job';
 WRONG_OPERATION = 'Wrong operation';
 WRONG_OPERATION_SEQUENCE = 'Wrong operation sequence';
 MASHINE_BUSY = 'Mashine is busy';
 JOB_BUSY = 'Previous operation of job didn''t complete';
 WRONG_TOTAL_TIME = 'Wrong total time';
 WRONG_ORDER = 'Wrong order of lines';
 JOBS_NOT_COMPLETE = 'Not all jobs completed';

type
 operation = record
              mashine:longint;
              len:longint;
             end;
 job = record
        cnt:longint;
        op:array[1..MAX_O] of operation;
       end;
 assigment = record
              t:longint;
              job, op:longint;
             end;
 log = array[1 .. MAX_J * MAX_O] of assigment;

var
 jobs:array[1..MAX_J] of job;

 m,j:longint;

 m_time:array[1..MAX_M] of longint;
 j_time:array[1..MAX_J] of longint;
 j_pos:array[1..MAX_J] of longint;

 best:longint;
 best_log_n:longint;
 best_log:log;

procedure reportError(s:String);
begin
 writeln('Error: ', s);
 halt(1);
end;

procedure reportAtLine(s:String;l:longint);
begin
 writeln('Error at line ', l, ' : ', s);
 halt(1);
end;

function max(a,b:longint):longint;
begin
 if (a<b) then max:=b else max:=a;
end;


function min(a,b:longint):longint;
begin
 if (a>b) then min:=b else min:=a;
end;



procedure read_input;
var
 f:text;
 l, k:longint;

begin
 assign(f, INPUT_FILE);
 reset(f);

 readln(f, m, j);
 for l:=1 to j do
 begin
  read(f, jobs[l].cnt);
  for k:=1 to jobs[l].cnt do
   read(f, jobs[l].op[k].mashine, jobs[l].op[k].len);
  readln(f);
 end;
 close(f);
end;

procedure read_output;
var
 f:text;
 l:longint;
begin
 {$I-}

 assign(f, OUTPUT_FILE);
 reset(f);

 readln(f, best);
 readln(f, best_log_n);

 if (ioresult <> 0) then reportError(IO_ERROR);

 for l:=1 to best_log_n do
 begin
  readln(f, best_log[l].t, best_log[l].job, best_log[l].op);
 end;

 if (ioresult <> 0) then reportError(IO_ERROR);

 close(f);

 {$I+}
end;

procedure verify;
var
 x_time, x_len:longint;
 x_job, x_op, x_mas:longint;
 l:longint;
 result:longint;

begin
 for l:=1 to m do m_time[l]:=0;
 for l:=1 to j do
 begin
  j_time[l]:= 0;
  j_pos[l] := 0;
 end;

 for l:= 1 to best_log_n do
 begin
  if (l <> 1) then
   if (best_log[l-1].t > best_log[l].t) then
      reportAtLine(WRONG_ORDER, l);

  if (best_log[l].job < 1) or (best_log[l].job > j) then
     reportAtLine(WRONG_JOB, l);

  x_job := best_log[l].job;

  if (best_log[l].op < 1) or (best_log[l].op > jobs[x_job].cnt) then
     reportAtLine(WRONG_OPERATION, l);

  x_op := best_log[l].op;

  if (x_op <> j_pos[x_job] + 1) then
     reportAtLine(WRONG_OPERATION_SEQUENCE, l);

  x_time := best_log[l].t;
  x_mas := jobs[x_job].op[x_op].mashine;
  x_len := jobs[x_job].op[x_op].len;

  if (x_time < m_time[x_mas]) then
     reportAtLine(MASHINE_BUSY, l);

  if (x_time < j_time[x_job]) then
     reportAtLine(JOB_BUSY, l);

  m_time[x_mas] := x_time + x_len;
  j_time[x_job] := x_time + x_len;;
  inc(j_pos[x_job]);
 end;

 for l:=1 to j do
 if (j_pos[l] <> jobs[l].cnt) then reportError(JOBS_NOT_COMPLETE);

 result:=0;
 for l:=1 to m do
  result:= max(result, m_time[l]);
 if (result <> best) then reportError(WRONG_TOTAL_TIME);
end;


begin
 read_input;
 read_output;
 verify;

 writeln('Solution correct. Total time=', best, '.');
end.